require 'zlib'
class User < ActiveRecord::Base
	
	def self.setTableName(key)
		self.table_name = self.getTableName(key)
    self
	end

	def self.getTableName(key)
  	las = Zlib::crc32(key.to_s).to_i.to_s
  	return "users#{las[0]}"
  end
  
	before_save do |r|
		unless r.id
			r.id = User.next_id
		end
		r.class.table_name = User.getTableName(r.id)
	end

	before_destroy do |r|
    r.class.table_name = User.getTableName(r.id)
  end

  def self.next_id
  	key = 'user_next_id'
  	REDIS.incr(key)
  	REDIS.get(key)
  end
end
